(function () {
  'use strict';

  (Drupal => {
    Drupal.behaviors.graupl = {
      attach: (context, settings) => {
        Object.keys(Drupal.behaviors.graupl.components).forEach(component => {
          if (typeof Drupal.behaviors.graupl.components[component].attach === "function") {
            try {
              Drupal.behaviors.graupl.components[component].attach(context, settings);
            } catch (error) {
              Drupal.throwError(error);
            }
          }
        });
      },
      detach: (context, settings, trigger) => {
        Object.keys(Drupal.behaviors.graupl.components).forEach(component => {
          if (typeof Drupal.behaviors.graupl.components[component].detach === "function") {
            try {
              Drupal.behaviors.graupl.components[component].detach(context, settings, trigger);
            } catch (error) {
              Drupal.throwError(error);
            }
          }
        });
      },
      components: {}
    };
  })(Drupal);

})();
