/**
 * @file
 * A helper for attaching behaviors for all Graupl components.
 */

((Drupal) => {
  Drupal.behaviors.graupl = {
    // Loop through all components and attach their behaviors.
    attach: (context, settings) => {
      Object.keys(Drupal.behaviors.graupl.components).forEach((component) => {
        if (typeof Drupal.behaviors.graupl.components[component].attach === "function") {
          try {
            Drupal.behaviors.graupl.components[component].attach(context, settings);
          } catch (error) {
            Drupal.throwError(error);
          }
        }
      });
    },
    // Loop through all components and detach their behaviors.
    detach: (context, settings, trigger) => {
      Object.keys(Drupal.behaviors.graupl.components).forEach((component) => {
        if (typeof Drupal.behaviors.graupl.components[component].detach === "function") {
          try {
            Drupal.behaviors.graupl.components[component].detach(context, settings, trigger);
          } catch (error) {
            Drupal.throwError(error);
          }
        }
      });
    },
    // Define all components.
    components: {}
  };
})(Drupal);
